import * as mc from '@minecraft/server';

export const console = mc.world.getDimension('minecraft:overworld');

export class database {
    constructor(id) {
        this.id = id;
        if (mc.world.scoreboard.getObjective(`${this.id}`) == null) {
            this.data = {};
            console.runCommandAsync(`scoreboard objectives add ${id} dummy ${id}`)
            console.runCommandAsync(`scoreboard players set ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id} 0`);
        } else {
            let participant = mc.world.scoreboard.getObjective(`${this.id}`).getParticipants()[0];
            this.data = JSON.parse(participant.displayName.replaceAll("'", '"'));
        }
    }
    set(value) {
        console.runCommandAsync(`scoreboard players reset ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id}`)
        this.data = value;
        console.runCommandAsync(`scoreboard players set ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id} 0`);
    }
    get() {
        let copy = JSON.stringify(this.data);
        return JSON.parse(copy);
    }
}